program PopOut;
{$APPTYPE CONSOLE}

uses
  Windows,
  SysUtils,
  IniFiles,
  ExtCtrls,
  IdAntiFreeze,
  IdPOP3,
  IdMessage;

{$R *.RES}

type
  TMyTimer = class(TObject)
  public
    procedure Timer1Timer(Sender: TObject);
  end;

var
  Msg: TIdMessage;
  pop: TIdPOP3;
  IdAntiFreeze1: TIdAntiFreeze;
  Timer1: TTimer;
  NumOfRcv, MsgCount,i: Integer;
  DelServerFile, GetHeaderOnly, GetNumOnly, GetMailSize: Boolean;
  Boundary, iniFileName: string;
  stderr: TextFile;
  MyTimer: TMyTimer;

procedure TMyTimer.Timer1Timer(Sender: TObject);
begin
  pop.Binding.CloseSocket;
  Writeln(stderr, 'T[oƂ̐ڑ^CAEg܂');
  Halt(1);
end;

procedure POPRetrieve(num: Integer);
begin
  Msg.Clear;
  Timer1.Enabled := True;
  try
    POP.RetrieveRaw(num, Msg.body);
  except
    Writeln(stderr, inttostr(num)+'Ԃ̃[̎MɎs܂');
    Halt(2);
  end;
  Timer1.Enabled := False;
  Writeln(Msg.body.text);
end;

procedure RetrievePOPHeaders(inMsgCount: Integer);
begin
  Msg.Clear;
  Timer1.Enabled := True;
  try
    POP.RetrieveHeader(inMsgCount, Msg);
  except
    Writeln(stderr, inttostr(inMsgCount)+'Ԃ̃[̃wb_擾Ɏs܂');
    Halt(2);
  end;
  Timer1.Enabled := False;
  Writeln(Msg.Headers.text);
end;

procedure RetrievePOPMsgSize(inMsgCount: Integer);
var size: Integer;
begin
  Msg.Clear;
  size := -1;
  Timer1.Enabled := True;
  try
    size := POP.RetrieveMsgSize(inMsgCount);
  except
    Writeln(stderr, inttostr(inMsgCount)+'Ԃ̃[̃TCY擾Ɏs܂');
    Halt(2);
  end;
  Timer1.Enabled := False;
  write(size);
end;


// --------------------------------------------------------- Main

begin
  DelServerFile := False;
  GetNumOnly := False;
  GetHeaderOnly := False;
  GetMailSize := False;
  NumOfRcv := 0;
  Boundary := '';

  AssignFile(stderr, 'CONOUT$');
  ReWrite(stderr);
  TTextRec(stderr).Handle := Integer(GetStdHandle(STD_ERROR_HANDLE));

  pop := TIdPOP3.create(nil);
  Msg := TIdMessage.create(nil);

  IdAntiFreeze1 := TIdAntiFreeze.Create(nil);
  with IdAntiFreeze1 do begin
    ApplicationHasPriority := True;
    OnlyWhenIdle := True;
    IdleTimeOut := 250;
    Active := True;
  end;
  
  MyTimer := TMyTimer.Create;

  Timer1 := TTimer.Create(nil);
  Timer1.Interval := 60000;
  Timer1.OnTimer := MyTimer.Timer1Timer;
  Timer1.Enabled := False;

  for i := 1 to ParamCount do begin
    if Copy(ParamStr(i), 1, 2) = '-i' then begin
      iniFileName := ParamStr(i+1);

      if FileExists(iniFileName) then
        with TIniFile.Create(ExpandFileName(iniFileName)) do
          try
            pop.Host := ReadString('POPOUT', 'SERVER', '');
            pop.UserID := ReadString('POPOUT', 'USER', '');
            pop.Password := ReadString('POPOUT', 'PASSWORD', '');
            Boundary := ReadString('POPOUT', 'Boundary', '');
            NumOfRcv := ReadInteger('POPOUT', 'NumOfRcv', 0);
            Timer1.Interval := ReadInteger('POPOUT', 'Timeout', 60000);
            DelServerFile := ReadBool('POPOUT', 'DelServerFile', False);
            GetHeaderOnly := ReadBool('POPOUT', 'GetHeaderOnly', False);
            GetMailSize := ReadBool('POPOUT', 'GetMailSize', False);
            GetNumOnly := ReadBool('POPOUT', 'GetNumOnly', False);
          finally
            Free;
          end;
    end;
  end;

  i := 1;
  while i <= ParamCount do begin
    if Copy(ParamStr(i),1,2)='-d' then begin
      DelServerFile := True;
    end else if Copy(ParamStr(i), 1, 2)='-n' then begin
      GetNumOnly := True;
    end else if Copy(ParamStr(i), 1, 2)='-h' then begin
      GetHeaderOnly := True;
    end else if Copy(ParamStr(i), 1, 2)='-m' then begin
      GetMailSize := True;
    end else if Copy(ParamStr(i), 1, 2)='-b' then begin
      inc(i);
      Boundary := ParamStr(i);
    end else if Copy(ParamStr(i), 1, 2)='-r' then begin
      inc(i);
      NumOfRcv := strtoint(ParamStr(i));
    end else if Copy(ParamStr(i), 1, 2)='-t' then begin
      inc(i);
      Timer1.Interval := strtoint64(ParamStr(i)) * 1000;
    end else if Copy(ParamStr(i), 1, 2)='-u' then begin
      inc(i);
      pop.UserID := ParamStr(i);
    end else if Copy(ParamStr(i), 1, 2)='-p' then begin
      inc(i);
      pop.Password := ParamStr(i);
    end else if Copy(ParamStr(i), 1, 2)='-s' then begin
      inc(i);
      pop.Host := ParamStr(i);
    end;
    inc(i);
  end;

  Timer1.Enabled := True;
  try
    POP.Connect;
  except
    Writeln(stderr, 'T[oڑG[');
    Halt(1);
  end;
  MsgCount := POP.CheckMessages;

  if GetNumOnly then begin
    Writeln(inttostr(MsgCount));
    pop.Disconnect;
    Exit;
  end;

  if GetHeaderOnly then begin
    if NumOfRcv > 0 then begin
      RetrievePOPHeaders(NumOfRcv);
      pop.Disconnect;
      Exit;
    end else begin
      Timer1.Enabled := False;
      for i := 1 to MsgCount do begin
        if Boundary <>'' then Writeln(Boundary);
        RetrievePOPHeaders(i);
      end;
      pop.Disconnect;
      Exit;
    end;
  end;

  if GetMailSize then begin
    if NumOfRcv > 0 then begin
      RetrievePOPMsgSize(NumOfRcv);
      Writeln('');
      pop.Disconnect;
      Exit;
    end else begin
      Timer1.Enabled := False;
      for i := 1 to MsgCount do begin
        write('Mail No. ', i, ' : ');
        RetrievePOPMsgSize(i);
        Writeln(' bytes');
      end;
      pop.Disconnect;
      Exit;
    end;
  end;

  if NumOfRcv > 0 then begin
    POPRetrieve(NumOfRcv);
    try
      if DelServerFile then POP.Delete(NumOfRcv);
    except
      Writeln(stderr, inttostr(NumOfRcv)+'Ԃ̃[̍폜Ɏs܂');
      Halt(3);
    end;
  end else begin
    for i := MsgCount downto 1 do begin
      if Boundary <>'' then Writeln(Boundary);
      POPRetrieve(i);
      try
        if DelServerFile then POP.Delete(i);
      except
        Writeln(stderr, inttostr(i)+'Ԃ̃[̍폜Ɉُ킪܂');
        Halt(3);
      end;
    end;
  end;

  pop.Disconnect;

end.

